Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.logging.log4j
Interface Logger

All Known Subinterfaces:
  ExtendedLogger

All Known Implementing Classes:
  AbstractLogger, ExtendedLoggerWrapper, SimpleLogger, StatusLogger

    public interface Logger

This is the central interface in the log4j package. Most logging operations, except configuration, are done through this interface.

The canonical way to obtain a Logger for a class is through `LogManager.getLogger()`. Typically, each class gets its own Logger named after its fully qualified class name (the default Logger name when obtained through the `LogManager.getLogger()` method). Thus, the simplest way to use this would be like so:

         public class MyClass {
             private static final Logger LOGGER = LogManager.getLogger();
             // ...
         }

For ease of filtering, searching, sorting, etc., it is generally a good idea to create Loggers for each class rather than sharing Loggers. Instead, `Markers` should be used for shared, filterable identification.

For service provider implementations, it is recommended to extend the `AbstractLogger` class rather than implementing this interface directly.

Method Summary
`void` | `catching(Level level, Throwable t)` Logs an exception or error that has been caught to a specific logging level.
`void` | `catching(Throwable t)` Logs an exception or error that has been caught.
`void` | `debug(Marker marker, Message msg)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Marker marker, Object message)` Logs a message object with the `DEBUG` level.
`void` | `debug(Marker marker, Object message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `debug(Marker marker, String message)` Logs a message object with the `DEBUG` level.
`void` | `debug(Marker marker, String message, Object... params)` Logs a message with parameters at the `DEBUG` level.
`void` | `debug(Marker marker, String message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `debug(Message msg)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Message msg, Throwable t)` Logs a message with the specific Marker at the `DEBUG` level.
`void` | `debug(Object message)` Logs a message object with the `DEBUG` level.
`void` | `debug(Object message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `debug(String message)` Logs a message object with the `DEBUG` level.
`void` | `debug(String message, Object... params)` Logs a message with parameters at the `DEBUG` level.
`void` | `debug(String message, Throwable t)` Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `entry()` Logs entry to a method.
`void` | `entry(Object... params)` Logs entry to a method along with its parameters.
`void` | `error(Marker marker, Message msg)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Marker marker, Object message)` Logs a message object with the `ERROR` level.
`void` | `error(Marker marker, Object message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `error(Marker marker, String message)` Logs a message object with the `ERROR` level.
`void` | `error(Marker marker, String message, Object... params)` Logs a message with parameters at the `ERROR` level.
`void` | `error(Marker marker, String message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `error(Message msg)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Message msg, Throwable t)` Logs a message with the specific Marker at the `ERROR` level.
`void` | `error(Object message)` Logs a message object with the `ERROR` level.
`void` | `error(Object message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `error(String message)` Logs a message object with the `ERROR` level.
`void` | `error(String message, Object... params)` Logs a message with parameters at the `ERROR` level.
`void` | `error(String message, Throwable t)` Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `exit()` Logs exit from a method.
`
`<R> R`
` | `exit(R result)` Logs exiting from a method with the result.
`void` | `fatal(Marker marker, Message msg)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Marker marker, Object message)` Logs a message object with the `FATAL` level.
`void` | `fatal(Marker marker, Object message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `fatal(Marker marker, String message)` Logs a message object with the `FATAL` level.
`void` | `fatal(Marker marker, String message, Object... params)` Logs a message with parameters at the `FATAL` level.
`void` | `fatal(Marker marker, String message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `fatal(Message msg)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Message msg, Throwable t)` Logs a message with the specific Marker at the `FATAL` level.
`void` | `fatal(Object message)` Logs a message object with the `FATAL` level.
`void` | `fatal(Object message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `fatal(String message)` Logs a message object with the `FATAL` level.
`void` | `fatal(String message, Object... params)` Logs a message with parameters at the `FATAL` level.
`void` | `fatal(String message, Throwable t)` Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.
`Level` | `getLevel()` Gets the Level associated with the Logger.
`MessageFactory` | `getMessageFactory()` Gets the message factory used to convert message Objects and Strings into actual log Messages.
`String` | `getName()` Gets the logger name.
`void` | `info(Marker marker, Message msg)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Marker marker, Object message)` Logs a message object with the `INFO` level.
`void` | `info(Marker marker, Object message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `info(Marker marker, String message)` Logs a message object with the `INFO` level.
`void` | `info(Marker marker, String message, Object... params)` Logs a message with parameters at the `INFO` level.
`void` | `info(Marker marker, String message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `info(Message msg)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Message msg, Throwable t)` Logs a message with the specific Marker at the `INFO` level.
`void` | `info(Object message)` Logs a message object with the `INFO` level.
`void` | `info(Object message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `info(String message)` Logs a message object with the `INFO` level.
`void` | `info(String message, Object... params)` Logs a message with parameters at the `INFO` level.
`void` | `info(String message, Throwable t)` Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.
`boolean` | `isDebugEnabled()` Checks whether this Logger is enabled for the `DEBUG` Level.
`boolean` | `isDebugEnabled(Marker marker)` Checks whether this Logger is enabled for the `DEBUG` Level.
`boolean` | `isEnabled(Level level)` Checks whether this Logger is enabled for the the given Level.
`boolean` | `isEnabled(Level level, Marker marker)` Checks whether this logger is enabled at the specified level and an optional Marker.
`boolean` | `isErrorEnabled()` Checks whether this Logger is enabled for the `ERROR` Level.
`boolean` | `isErrorEnabled(Marker marker)` Checks whether this Logger is enabled for the `ERROR` Level.
`boolean` | `isFatalEnabled()` Checks whether this Logger is enabled for the `FATAL` Level.
`boolean` | `isFatalEnabled(Marker marker)` Checks whether this Logger is enabled for the `FATAL` Level.
`boolean` | `isInfoEnabled()` Checks whether this Logger is enabled for the `INFO` Level.
`boolean` | `isInfoEnabled(Marker marker)` Checks whether this Logger is enabled for the `INFO` Level.
`boolean` | `isTraceEnabled()` Checks whether this Logger is enabled for the `TRACE` level.
`boolean` | `isTraceEnabled(Marker marker)` Checks whether this Logger is enabled for the `TRACE` level.
`boolean` | `isWarnEnabled()` Checks whether this Logger is enabled for the `WARN` Level.
`boolean` | `isWarnEnabled(Marker marker)` Checks whether this Logger is enabled for the `WARN` Level.
`void` | `log(Level level, Marker marker, Message msg)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Marker marker, Object message)` Logs a message object with the given level.
`void` | `log(Level level, Marker marker, Object message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `log(Level level, Marker marker, String message)` Logs a message object with the given level.
`void` | `log(Level level, Marker marker, String message, Object... params)` Logs a message with parameters at the given level.
`void` | `log(Level level, Marker marker, String message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `log(Level level, Message msg)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Message msg, Throwable t)` Logs a message with the specific Marker at the given level.
`void` | `log(Level level, Object message)` Logs a message object with the given level.
`void` | `log(Level level, Object message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `log(Level level, String message)` Logs a message object with the given level.
`void` | `log(Level level, String message, Object... params)` Logs a message with parameters at the given level.
`void` | `log(Level level, String message, Throwable t)` Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `printf(Level level, Marker marker, String format, Object... params)` Logs a formatted message using the specified format string and arguments.
`void` | `printf(Level level, String format, Object... params)` Logs a formatted message using the specified format string and arguments.
`
`<T extends Throwable> T`
` | `throwing(Level level, T t)` Logs an exception or error to be thrown.
`
`<T extends Throwable> T`
` | `throwing(T t)` Logs an exception or error to be thrown.
`void` | `trace(Marker marker, Message msg)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Marker marker, Object message)` Logs a message object with the `TRACE` level.
`void` | `trace(Marker marker, Object message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `trace(Marker marker, String message)` Logs a message object with the `TRACE` level.
`void` | `trace(Marker marker, String message, Object... params)` Logs a message with parameters at the `TRACE` level.
`void` | `trace(Marker marker, String message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `trace(Message msg)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Message msg, Throwable t)` Logs a message with the specific Marker at the `TRACE` level.
`void` | `trace(Object message)` Logs a message object with the `TRACE` level.
`void` | `trace(Object message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `trace(String message)` Logs a message object with the `TRACE` level.
`void` | `trace(String message, Object... params)` Logs a message with parameters at the `TRACE` level.
`void` | `trace(String message, Throwable t)` Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(Marker marker, Message msg)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Marker marker, Message msg, Throwable t)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Marker marker, Object message)` Logs a message object with the `WARN` level.
`void` | `warn(Marker marker, Object message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(Marker marker, String message)` Logs a message object with the `WARN` level.
`void` | `warn(Marker marker, String message, Object... params)` Logs a message with parameters at the `WARN` level.
`void` | `warn(Marker marker, String message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(Message msg)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Message msg, Throwable t)` Logs a message with the specific Marker at the `WARN` level.
`void` | `warn(Object message)` Logs a message object with the `WARN` level.
`void` | `warn(Object message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.
`void` | `warn(String message)` Logs a message object with the `WARN` level.
`void` | `warn(String message, Object... params)` Logs a message with parameters at the `WARN` level.
`void` | `warn(String message, Throwable t)` Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

Method Detail

### catching

    void catching(Level level,
                  Throwable t)

  Logs an exception or error that has been caught to a specific logging level.

  Parameters:
    `level` - The logging Level.
    `t` - The Throwable.

### catching

    void catching(Throwable t)

  Logs an exception or error that has been caught. Normally, one may wish to provide additional information with an exception while logging it; in these cases, one would not use this method. In other cases where simply logging the fact that an exception was swallowed somewhere (e.g., at the top of the stack trace in a `main()` method), this method is ideal for it.

  Parameters:
    `t` - The Throwable.

### debug

    void debug(Marker marker,
               Message msg)

  Logs a message with the specific Marker at the `DEBUG` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### debug

    void debug(Marker marker,
               Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `DEBUG` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### debug

    void debug(Marker marker,
               Object message)

  Logs a message object with the `DEBUG` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### debug

    void debug(Marker marker,
               Object message,
               Throwable t)

  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### debug

    void debug(Marker marker,
               String message)

  Logs a message object with the `DEBUG` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### debug

    void debug(Marker marker,
               String message,
               Object... params)

  Logs a message with parameters at the `DEBUG` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `getMessageFactory()`

### debug

    void debug(Marker marker,
               String message,
               Throwable t)

  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### debug

    void debug(Message msg)

  Logs a message with the specific Marker at the `DEBUG` level.

  Parameters:
    `msg` - the message string to be logged

### debug

    void debug(Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `DEBUG` level.

  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### debug

    void debug(Object message)

  Logs a message object with the `DEBUG` level.

  Parameters:
    `message` - the message object to log.

### debug

    void debug(Object message,
               Throwable t)

  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### debug

    void debug(String message)

  Logs a message object with the `DEBUG` level.

  Parameters:
    `message` - the message string to log.

### debug

    void debug(String message,
               Object... params)

  Logs a message with parameters at the `DEBUG` level.

  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `getMessageFactory()`

### debug

    void debug(String message,
               Throwable t)

  Logs a message at the `DEBUG` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### entry

    void entry()

  Logs entry to a method. Used when the method in question has no parameters or when the parameters should not be logged.

### entry

    void entry(Object... params)

  Logs entry to a method along with its parameters. For example,

           public void doSomething(String foo, int bar) {
               LOGGER.entry(foo, bar);
               // do something
           }

  The use of methods such as this are more effective when combined with aspect-oriented programming or other bytecode manipulation tools. It can be rather tedious (and messy) to use this type of method manually.

  Parameters:
    `params` - The parameters to the method. TODO Use of varargs results in array creation which can be a substantial portion of no-op case. LogMF/LogSF provides several overrides to avoid vararg except in edge cases. (RG) LogMF and LogSF implement these in LogXF which calls logger.callAppenders. callAppenders is part of the implementation and cannot be used by the API. Adding more methods here and in AbstractLogger is sufficient.

### error

    void error(Marker marker,
               Message msg)

  Logs a message with the specific Marker at the `ERROR` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### error

    void error(Marker marker,
               Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `ERROR` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### error

    void error(Marker marker,
               Object message)

  Logs a message object with the `ERROR` level.

  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.

### error

    void error(Marker marker,
               Object message,
               Throwable t)

  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### error

    void error(Marker marker,
               String message)

  Logs a message object with the `ERROR` level.

  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.

### error

    void error(Marker marker,
               String message,
               Object... params)

  Logs a message with parameters at the `ERROR` level.

  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant error, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### error

    void error(Marker marker,
               String message,
               Throwable t)

  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### error

    void error(Message msg)

  Logs a message with the specific Marker at the `ERROR` level.

  Parameters:
    `msg` - the message string to be logged

### error

    void error(Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `ERROR` level.

  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### error

    void error(Object message)

  Logs a message object with the `ERROR` level.

  Parameters:
    `message` - the message object to log.

### error

    void error(Object message,
               Throwable t)

  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### error

    void error(String message)

  Logs a message object with the `ERROR` level.

  Parameters:
    `message` - the message string to log.

### error

    void error(String message,
               Object... params)

  Logs a message with parameters at the `ERROR` level.

  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant error, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### error

    void error(String message,
               Throwable t)

  Logs a message at the `ERROR` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### exit

    void exit()

  Logs exit from a method. Used for methods that do not return anything.

### exit

    <R> R exit(R result)

  Logs exiting from a method with the result. This may be coded as:

           return LOGGER.exit(myResult);

  Type Parameters:
    `R` - The type of the parameter and object being returned.
  Parameters:
    `result` - The result being returned from the method call.
  Returns:
    the result.

### fatal

    void fatal(Marker marker,
               Message msg)

  Logs a message with the specific Marker at the `FATAL` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### fatal

    void fatal(Marker marker,
               Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `FATAL` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### fatal

    void fatal(Marker marker,
               Object message)

  Logs a message object with the `FATAL` level.

  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.

### fatal

    void fatal(Marker marker,
               Object message,
               Throwable t)

  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### fatal

    void fatal(Marker marker,
               String message)

  Logs a message object with the `FATAL` level.

  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.

### fatal

    void fatal(Marker marker,
               String message,
               Object... params)

  Logs a message with parameters at the `FATAL` level.

  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call.(RG) I assume you meant fatal, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### fatal

    void fatal(Marker marker,
               String message,
               Throwable t)

  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - The marker data specific to this log statement.
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### fatal

    void fatal(Message msg)

  Logs a message with the specific Marker at the `FATAL` level.

  Parameters:
    `msg` - the message string to be logged

### fatal

    void fatal(Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `FATAL` level.

  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### fatal

    void fatal(Object message)

  Logs a message object with the `FATAL` level.

  Parameters:
    `message` - the message object to log.

### fatal

    void fatal(Object message,
               Throwable t)

  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### fatal

    void fatal(String message)

  Logs a message object with the `FATAL` level.

  Parameters:
    `message` - the message string to log.

### fatal

    void fatal(String message,
               Object... params)

  Logs a message with parameters at the `FATAL` level.

  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call.(RG) I assume you meant fatal, not info. It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### fatal

    void fatal(String message,
               Throwable t)

  Logs a message at the `FATAL` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### getLevel

    Level getLevel()

  Gets the Level associated with the Logger.

  Returns:
    the Level associate with the Logger.

### getMessageFactory

    MessageFactory getMessageFactory()

  Gets the message factory used to convert message Objects and Strings into actual log Messages.

  Returns:
    the message factory.

### getName

    String getName()

  Gets the logger name.

  Returns:
    the logger name.

### info

    void info(Marker marker,
              Message msg)

  Logs a message with the specific Marker at the `INFO` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### info

    void info(Marker marker,
              Message msg,
              Throwable t)

  Logs a message with the specific Marker at the `INFO` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### info

    void info(Marker marker,
              Object message)

  Logs a message object with the `INFO` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### info

    void info(Marker marker,
              Object message,
              Throwable t)

  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### info

    void info(Marker marker,
              String message)

  Logs a message object with the `INFO` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### info

    void info(Marker marker,
              String message,
              Object... params)

  Logs a message with parameters at the `INFO` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### info

    void info(Marker marker,
              String message,
              Throwable t)

  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### info

    void info(Message msg)

  Logs a message with the specific Marker at the `INFO` level.

  Parameters:
    `msg` - the message string to be logged

### info

    void info(Message msg,
              Throwable t)

  Logs a message with the specific Marker at the `INFO` level.

  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### info

    void info(Object message)

  Logs a message object with the `INFO` level.

  Parameters:
    `message` - the message object to log.

### info

    void info(Object message,
              Throwable t)

  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### info

    void info(String message)

  Logs a message object with the `INFO` level.

  Parameters:
    `message` - the message string to log.

### info

    void info(String message,
              Object... params)

  Logs a message with parameters at the `INFO` level.

  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) It isn't possible to be misinterpreted as the previous method is for that signature. Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### info

    void info(String message,
              Throwable t)

  Logs a message at the `INFO` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### isDebugEnabled

    boolean isDebugEnabled()

  Checks whether this Logger is enabled for the `DEBUG` Level.

  Returns:
    boolean - `true` if this Logger is enabled for level DEBUG, `false` otherwise.

### isDebugEnabled

    boolean isDebugEnabled(Marker marker)

  Checks whether this Logger is enabled for the `DEBUG` Level.

  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level DEBUG, `false` otherwise.

### isEnabled

    boolean isEnabled(Level level)

  Checks whether this Logger is enabled for the the given Level.

  Note that passing in `OFF` always returns `true`.

  Parameters:
    `level` - the level to check
  Returns:
    boolean - `true` if this Logger is enabled for level, `false` otherwise.

### isEnabled

    boolean isEnabled(Level level,
                      Marker marker)

  Checks whether this logger is enabled at the specified level and an optional Marker.

  Parameters:
    `level` - The Level to check.
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `WARN`, `false` otherwise.

### isErrorEnabled

    boolean isErrorEnabled()

  Checks whether this Logger is enabled for the `ERROR` Level.

  Returns:
    boolean - `true` if this Logger is enabled for level `ERROR`, `false` otherwise.

### isErrorEnabled

    boolean isErrorEnabled(Marker marker)

  Checks whether this Logger is enabled for the `ERROR` Level.

  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `ERROR`, `false` otherwise.

### isFatalEnabled

    boolean isFatalEnabled()

  Checks whether this Logger is enabled for the `FATAL` Level.

  Returns:
    boolean - `true` if this Logger is enabled for level `FATAL`, `false` otherwise.

### isFatalEnabled

    boolean isFatalEnabled(Marker marker)

  Checks whether this Logger is enabled for the `FATAL` Level.

  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `FATAL`, `false` otherwise.

### isInfoEnabled

    boolean isInfoEnabled()

  Checks whether this Logger is enabled for the `INFO` Level.

  Returns:
    boolean - `true` if this Logger is enabled for level INFO, `false` otherwise.

### isInfoEnabled

    boolean isInfoEnabled(Marker marker)

  Checks whether this Logger is enabled for the `INFO` Level.

  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level INFO, `false` otherwise.

### isTraceEnabled

    boolean isTraceEnabled()

  Checks whether this Logger is enabled for the `TRACE` level.

  Returns:
    boolean - `true` if this Logger is enabled for level TRACE, `false` otherwise.

### isTraceEnabled

    boolean isTraceEnabled(Marker marker)

  Checks whether this Logger is enabled for the `TRACE` level.

  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level TRACE, `false` otherwise.

### isWarnEnabled

    boolean isWarnEnabled()

  Checks whether this Logger is enabled for the `WARN` Level.

  Returns:
    boolean - `true` if this Logger is enabled for level `WARN`, `false` otherwise.

### isWarnEnabled

    boolean isWarnEnabled(Marker marker)

  Checks whether this Logger is enabled for the `WARN` Level.

  Parameters:
    `marker` - The marker data specific to this log statement.
  Returns:
    boolean - `true` if this Logger is enabled for level `WARN`, `false` otherwise.

### log

    void log(Level level,
             Marker marker,
             Message msg)

  Logs a message with the specific Marker at the given level.

  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### log

    void log(Level level,
             Marker marker,
             Message msg,
             Throwable t)

  Logs a message with the specific Marker at the given level.

  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### log

    void log(Level level,
             Marker marker,
             Object message)

  Logs a message object with the given level.

  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### log

    void log(Level level,
             Marker marker,
             Object message,
             Throwable t)

  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### log

    void log(Level level,
             Marker marker,
             String message)

  Logs a message object with the given level.

  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### log

    void log(Level level,
             Marker marker,
             String message,
             Object... params)

  Logs a message with parameters at the given level.

  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `getMessageFactory()`

### log

    void log(Level level,
             Marker marker,
             String message,
             Throwable t)

  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `level` - the logging level
    `marker` - the marker data specific to this log statement
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### log

    void log(Level level,
             Message msg)

  Logs a message with the specific Marker at the given level.

  Parameters:
    `level` - the logging level
    `msg` - the message string to be logged

### log

    void log(Level level,
             Message msg,
             Throwable t)

  Logs a message with the specific Marker at the given level.

  Parameters:
    `level` - the logging level
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### log

    void log(Level level,
             Object message)

  Logs a message object with the given level.

  Parameters:
    `level` - the logging level
    `message` - the message object to log.

### log

    void log(Level level,
             Object message,
             Throwable t)

  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `level` - the logging level
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### log

    void log(Level level,
             String message)

  Logs a message object with the given level.

  Parameters:
    `level` - the logging level
    `message` - the message string to log.

### log

    void log(Level level,
             String message,
             Object... params)

  Logs a message with parameters at the given level.

  Parameters:
    `level` - the logging level
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `getMessageFactory()`

### log

    void log(Level level,
             String message,
             Throwable t)

  Logs a message at the given level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `level` - the logging level
    `message` - the message to log.
    `t` - the exception to log, including its stack trace.

### printf

    void printf(Level level,
                Marker marker,
                String format,
                Object... params)

  Logs a formatted message using the specified format string and arguments.

  Parameters:
    `level` - The logging Level.
    `marker` - the marker data specific to this log statement.
    `format` - The format String.
    `params` - Arguments specified by the format.

### printf

    void printf(Level level,
                String format,
                Object... params)

  Logs a formatted message using the specified format string and arguments.

  Parameters:
    `level` - The logging Level.
    `format` - The format String.
    `params` - Arguments specified by the format.

### throwing

    <T extends Throwable> T throwing(Level level,
                                     T t)

  Logs an exception or error to be thrown. This may be coded as:

           throw logger.throwing(Level.DEBUG, myException);

  Type Parameters:
    `T` - the Throwable type.
  Parameters:
    `level` - The logging Level.
    `t` - The Throwable.
  Returns:
    the Throwable.

### throwing

    <T extends Throwable> T throwing(T t)

  Logs an exception or error to be thrown. This may be coded as:

           throw logger.throwing(myException);

  Type Parameters:
    `T` - the Throwable type.
  Parameters:
    `t` - The Throwable.
  Returns:
    the Throwable.

### trace

    void trace(Marker marker,
               Message msg)

  Logs a message with the specific Marker at the `TRACE` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### trace

    void trace(Marker marker,
               Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `TRACE` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### trace

    void trace(Marker marker,
               Object message)

  Logs a message object with the `TRACE` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### trace

    void trace(Marker marker,
               Object message,
               Throwable t)

  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `debug(String)`

### trace

    void trace(Marker marker,
               String message)

  Logs a message object with the `TRACE` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message string to log.

### trace

    void trace(Marker marker,
               String message,
               Object... params)

  Logs a message with parameters at the `TRACE` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `getMessageFactory()`

### trace

    void trace(Marker marker,
               String message,
               Throwable t)

  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `debug(String)`

### trace

    void trace(Message msg)

  Logs a message with the specific Marker at the `TRACE` level.

  Parameters:
    `msg` - the message string to be logged

### trace

    void trace(Message msg,
               Throwable t)

  Logs a message with the specific Marker at the `TRACE` level.

  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### trace

    void trace(Object message)

  Logs a message object with the `TRACE` level.

  Parameters:
    `message` - the message object to log.

### trace

    void trace(Object message,
               Throwable t)

  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `debug(String)`

### trace

    void trace(String message)

  Logs a message object with the `TRACE` level.

  Parameters:
    `message` - the message string to log.

### trace

    void trace(String message,
               Object... params)

  Logs a message with parameters at the `TRACE` level.

  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `getMessageFactory()`

### trace

    void trace(String message,
               Throwable t)

  Logs a message at the `TRACE` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.
  See Also:
    `debug(String)`

### warn

    void warn(Marker marker,
              Message msg)

  Logs a message with the specific Marker at the `WARN` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged

### warn

    void warn(Marker marker,
              Message msg,
              Throwable t)

  Logs a message with the specific Marker at the `WARN` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### warn

    void warn(Marker marker,
              Object message)

  Logs a message object with the `WARN` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### warn

    void warn(Marker marker,
              Object message,
              Throwable t)

  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### warn

    void warn(Marker marker,
              String message)

  Logs a message object with the `WARN` level.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.

### warn

    void warn(Marker marker,
              String message,
              Object... params)

  Logs a message with parameters at the `WARN` level.

  Parameters:
    `marker` - the marker data specific to this log statement.
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant warn, not info. It isn't possible to be misinterpreted as the previous method is for that signature.Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### warn

    void warn(Marker marker,
              String message,
              Throwable t)

  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `marker` - the marker data specific to this log statement
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### warn

    void warn(Message msg)

  Logs a message with the specific Marker at the `WARN` level.

  Parameters:
    `msg` - the message string to be logged

### warn

    void warn(Message msg,
              Throwable t)

  Logs a message with the specific Marker at the `WARN` level.

  Parameters:
    `msg` - the message string to be logged
    `t` - A Throwable or null.

### warn

    void warn(Object message)

  Logs a message object with the `WARN` level.

  Parameters:
    `message` - the message object to log.

### warn

    void warn(Object message,
              Throwable t)

  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

### warn

    void warn(String message)

  Logs a message object with the `WARN` level.

  Parameters:
    `message` - the message string to log.

### warn

    void warn(String message,
              Object... params)

  Logs a message with parameters at the `WARN` level.

  Parameters:
    `message` - the message to log; the format depends on the message factory.
    `params` - parameters to the message.
  See Also:
    `TODO Likely to misinterpret existing log4j client code that intended to call info(Object,Throwable). Incurs array creation expense on every call. (RG) I assume you meant warn, not info. It isn't possible to be misinterpreted as the previous method is for that signature.Methods should be added to avoid varargs for 1, 2 or 3 parameters.`

### warn

    void warn(String message,
              Throwable t)

  Logs a message at the `WARN` level including the stack trace of the `Throwable` `t` passed as parameter.

  Parameters:
    `message` - the message object to log.
    `t` - the exception to log, including its stack trace.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2015 Apache Software Foundation. All Rights Reserved.
Apache Logging, Apache Log4j, Log4j, Apache, the Apache feather logo, the Apache Logging project logo, and the Apache Log4j logo are trademarks of The Apache Software Foundation.